//----------------------------------------------------------------------------
//
// File:        ti994a-sdl.hpp
// Date:        18-Apr-2000
// Programmer:  Marc Rousseau
//
// Description:
//
// Copyright (c) 2000 Marc Rousseau, All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
//
// Revision History:
//
//----------------------------------------------------------------------------

#ifndef _TI994A_SDL_HPP_
#define _TI994A_SDL_HPP_

#if ! defined ( _TI994A_HPP_ )
    #error You must include TI994A.hpp before TI994A-sdl.hpp
#endif

struct SDL_Thread;

class cSdlTI994A : public cTI994A {

    ULONG         m_StartTime;
    ULONG         m_StopTime;

    bool          m_Running;
    SDL_Thread   *m_Thread;

    bool          m_CapsLock;
    int           m_ColumnSelect;
    UCHAR         m_StateTable [ 512 ];

    virtual int   ReadCRU ( ADDRESS );
    virtual void  WriteCRU ( ADDRESS, USHORT );

    bool isSpecial ( USHORT );

    void SetSpecial ( USHORT );
    void ClearSpecial ( USHORT );

    void KeyPressed ( USHORT );
    void KeyReleased ( USHORT );

    void StartThread ();
    void StopThread ();

    void Reset ();
    void RetraceTimer ();

    static int _TimerHookProc ();
    int TimerHookProc ();

    static int _RunThreadProc ( void * );
    int RunThreadProc ();

public:

    cSdlTI994A ( cCartridge *ctg );
    ~cSdlTI994A ();

    virtual void Run ();

};

#endif
