;----------------------------------------------------------------------------
;
; File:        _opcodes.asm
; Date:        23-Feb-1998
; Programmer:  Marc Rousseau
;
; Description:
;
; Copyright (c) 1994-2000 Marc Rousseau, All Rights Reserved.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
;
; Revision History:
;
;----------------------------------------------------------------------------

	.386p
	IDEAL
	JUMPS
	MODEL	USE32 FLAT, CPP, OS2

	INCLUDE	"TMS9900.INC"

	DATASEG

srcComp		dd	0
dstComp		dd	0
flagLogical	db	0
flagArithmetic	db	0
flagEqual	db	0
flagCarry	db	0
flagOverflow	db	0
flagParity	db	0
flagXOP		db	0
intLevel	db	0

	PUBLIC	intLevel

	EXTRN	CpuMemoryW  : WORD, CpuMemoryB : BYTE
	EXTRN	_CRU_Object : DWORD

	CODESEG

	EXTRN	Run : NEAR, Step : NEAR, ExecuteInstruction : NEAR
	EXTRN	GetArgumentW : NEAR, GetArgumentB  : NEAR
	EXTRN	ReadMemoryW  : NEAR, ReadMemoryB   : NEAR
	EXTRN	WriteMemoryW : NEAR, WriteMemoryB  : NEAR
	EXTRN	_ReadMemoryB : NEAR, _WriteMemoryB : NEAR
	EXTRN	_ReadMemoryW : NEAR, _WriteMemoryW : NEAR

	EXTRN	_WriteCRU    : NEAR, _ReadCRU      : NEAR

	PUBLIC	SetStatus, GetStatus

	PUBLIC	_opcode_A     , _opcode_AB    , _opcode_ABS   , _opcode_AI
	PUBLIC	_opcode_ANDI  , _opcode_B     , _opcode_BL    , _opcode_BLWP
	PUBLIC	_opcode_C     , _opcode_CB    , _opcode_CI    , _opcode_CKOF
	PUBLIC	_opcode_CKON  , _opcode_CLR   , _opcode_COC   , _opcode_CZC
	PUBLIC	_opcode_DEC   , _opcode_DECT  , _opcode_DIV   , _opcode_IDLE
	PUBLIC	_opcode_INC   , _opcode_INCT  , _opcode_INV   , _opcode_JEQ
	PUBLIC	_opcode_JGT   , _opcode_JH    , _opcode_JHE   , _opcode_JL
	PUBLIC	_opcode_JLE   , _opcode_JLT   , _opcode_JMP   , _opcode_JNC
	PUBLIC	_opcode_JNE   , _opcode_JNO   , _opcode_JOC   , _opcode_JOP
	PUBLIC	_opcode_LDCR  , _opcode_LI    , _opcode_LIMI  , _opcode_LREX
	PUBLIC	_opcode_LWPI  , _opcode_MOV   , _opcode_MOVB  , _opcode_MPY
	PUBLIC	_opcode_NEG   , _opcode_ORI   , _opcode_RSET  , _opcode_RTWP
	PUBLIC	_opcode_S     , _opcode_SB    , _opcode_SBO   , _opcode_SBZ
	PUBLIC	_opcode_SETO  , _opcode_SLA   , _opcode_SOC   , _opcode_SOCB
	PUBLIC	_opcode_SRA   , _opcode_SRC   , _opcode_SRL   , _opcode_STCR
	PUBLIC	_opcode_STST  , _opcode_STWP  , _opcode_SWPB  , _opcode_SZC
	PUBLIC	_opcode_SZCB  , _opcode_TB    , _opcode_X     , _opcode_XOP
	PUBLIC	_opcode_XOR

	PUBLIC  ContextSwitch

PROC	ContextSwitch

	xchg	_WP_, eax
	xchg	_PC_, ebx
	call	GetStatus
	mov	[ CpuMemoryW + _WP_ + 13 * 2 ], ax
	mov	[ CpuMemoryW + _WP_ + 14 * 2 ], bx
	mov	[ CpuMemoryW + _WP_ + 15 * 2 ], dx
	ret

ENDP	ContextSwitch

PROC	GetStatus

	mov	edx, [ srcComp ]
	cmp	dx, [ word ptr dstComp ]
	seta	[ flagLogical ]
	setg	[ flagArithmetic ]
	sete	[ flagEqual ]

	mov	dh, [ flagLogical ]
	shl	dh, 1
	or	dh, [ flagArithmetic ]
	shl	dh, 1
	or	dh, [ flagEqual ]
	shl	dh, 1
	or	dh, [ flagCarry ]
	shl	dh, 1
	or	dh, [ flagOverflow ]
	shl	dh, 1
	or	dh, [ flagParity ]
	shl	dh, 1
	or	dh, [ flagXOP ]
	shl	dh, 1

	mov	dl, [ intLevel ]

	ret

ENDP	GetStatus

PROC	SetStatus

	mov	[ intLevel ], dl

	test	dh, TMS_CARRY
	setne	[ flagCarry ]
	test	dh, TMS_OVERFLOW
	setne	[ flagOverflow ]
	test	dh, TMS_PARITY
	setne	[ flagParity ]
	test	dh, TMS_XOP
	setne	[ flagXOP ]

	mov	[ srcComp ], 0
	mov	[ dstComp ], 0

	test	dh, TMS_EQUAL
	jne	@@Done

	inc	[ dstComp ]
	test	dh, TMS_LOGICAL OR TMS_ARITHMETIC
	je	@@Done
	mov	edi, [ srcComp ]
	xchg	edi, [ dstComp ]
	mov	[ srcComp ], edi
	test	dh, TMS_LOGICAL
	jne	@@xxx
	dec	[ dstComp ]
	jmp	@@Done

@@xxx:

	test	dh, TMS_ARITHMETIC
	jne	@@Done
	neg	[ srcComp ]

@@Done:

	ret

ENDP	SetStatus

;-----------------------------------------------------------------------------
;    LI		Format: VIII	Op-code: 0x0200		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_LI

	and	eax, 0000000Fh
	movzx	ebx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_LI

;-----------------------------------------------------------------------------
;    AI		Format: VIII	Op-code: 0x0220		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_AI

	mov	ecx, eax
	and	ecx, 0000000Fh
	mov	bx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	mov	dx, [ CpuMemoryW + _WP_ + ecx * 2 ]
	add	bx, dx
	mov	[ CpuMemoryW + _WP_ + ecx * 2 ], bx
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_AI

;-----------------------------------------------------------------------------
;    ANDI	Format: VIII	Op-code: 0x0240		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_ANDI

	and	eax, 0000000Fh
	movzx	ebx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	mov	dx, [ CpuMemoryW + _WP_ + eax * 2 ]
	and	bx, dx
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_ANDI

;-----------------------------------------------------------------------------
;    ORI	Format: VIII	Op-code: 0x0260		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_ORI

	and	eax, 0000000Fh
	movzx	ebx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	mov	dx, [ CpuMemoryW + _WP_ + eax * 2 ]
	or	bx, dx
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_ORI

;-----------------------------------------------------------------------------
;    CI		Format: VIII	Op-code: 0x0280		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_CI

	and	eax, 0000000Fh
	movzx	edx, [ CpuMemoryW + _PC_ ]
	add	_PCw_, 2
	movzx	ebx, [ CpuMemoryW + _WP_ + eax * 2 ]
	mov	[ srcComp ], ebx
	mov	[ dstComp ], edx
	ret

ENDP	_opcode_CI

;-----------------------------------------------------------------------------
;    STWP	Format: VIII	Op-code: 0x02A0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_STWP

	and	eax, 0000000Fh
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], _WPw_
	ret

ENDP	_opcode_STWP

;-----------------------------------------------------------------------------
;    STST	Format: VIII	Op-code: 0x02C0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_STST

	and	eax, 0000000Fh
	call	GetStatus
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], dx
	ret

ENDP	_opcode_STST

;-----------------------------------------------------------------------------
;    LWPI	Format: VIII	Op-code: 0x02E0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_LWPI

	call	GetArgumentW
	mov	_WP_, ecx
	ret

ENDP	_opcode_LWPI

;-----------------------------------------------------------------------------
;    LIMI	Format: VIII	Op-code: 0x0300		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_LIMI

	mov	al, [ CpuMemoryB + _PC_ ]
	mov	[ intLevel ], al
	add	_PCw_, 2
	ret

ENDP	_opcode_LIMI

;-----------------------------------------------------------------------------
;    IDLE	Format: VII	Op-code: 0x0340		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_IDLE
	ret
ENDP	_opcode_IDLE

;-----------------------------------------------------------------------------
;    RSET	Format: VII	Op-code: 0x0360		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_RSET
	ret
ENDP	_opcode_RSET

;-----------------------------------------------------------------------------
;    RTWP	Format: VII	Op-code: 0x0380		Status: L A E C O P X
;-----------------------------------------------------------------------------
PROC	_opcode_RTWP

	mov	dx, [ CpuMemoryW + _WP_ + 15 * 2 ]
	mov	_PCw_, [ CpuMemoryW + _WP_ + 14 * 2 ]
	mov	_WPw_, [ CpuMemoryW + _WP_ + 13 * 2 ]
	call	SetStatus
	ret

ENDP	_opcode_RTWP

;-----------------------------------------------------------------------------
;    CKON	Format: VII	Op-code: 0x03A0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_CKON
	ret
ENDP	_opcode_CKON

;-----------------------------------------------------------------------------
;    CKOF	Format: VII	Op-code: 0x03C0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_CKOF
	ret
ENDP	_opcode_CKOF

;-----------------------------------------------------------------------------
;    LREX	Format: VII	Op-code: 0x03E0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_LREX
	ret
ENDP	_opcode_LREX

;-----------------------------------------------------------------------------
;    BLWP	Format: VI	Op-code: 0x0400		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_BLWP

	call	GetArgumentW
	movzx	eax, [ CpuMemoryW + ecx ]
	movzx	ebx, [ CpuMemoryW + ecx + 2 ]
	call	ContextSwitch
	ret

ENDP	_opcode_BLWP

;-----------------------------------------------------------------------------
;    B		Format: VI	Op-code: 0x0440		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_B

	call	GetArgumentW
	mov	_PC_, ecx
	ret

ENDP	_opcode_B

;-----------------------------------------------------------------------------
;    X		Format: VI	Op-code: 0x0480		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_X

	call	GetArgumentW
	movzx	eax, [ CpuMemoryW + ecx ]
	call	ExecuteInstruction
	ret

ENDP	_opcode_X

;-----------------------------------------------------------------------------
;    CLR	Format: VI	Op-code: 0x04C0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_CLR

	call	GetArgumentW
	xor	ebx, ebx
	call	_WriteMemoryW
	ret

ENDP	_opcode_CLR

;-----------------------------------------------------------------------------
;    NEG	Format: VI	Op-code: 0x0500		Status: L A E - O - -
;-----------------------------------------------------------------------------
PROC	_opcode_NEG

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	neg	bx
	seto	[ flagOverflow ];
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_NEG

;-----------------------------------------------------------------------------
;    INV	Format: VI	Op-code: 0x0540		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_INV

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	not	ebx
	call	_WriteMemoryW
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_INV

;-----------------------------------------------------------------------------
;    INC	Format: VI	Op-code: 0x0580		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_INC

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	add	bx, 1
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_INC

;-----------------------------------------------------------------------------
;    INCT	Format: VI	Op-code: 0x05C0		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_INCT

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	add	bx, 2
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_INCT

;-----------------------------------------------------------------------------
;    DEC	Format: VI	Op-code: 0x0600		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_DEC

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	add	bx, -1
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_DEC

;-----------------------------------------------------------------------------
;    DECT	Format: VI	Op-code: 0x0640		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_DECT

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	add	bx, -2
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_DECT

;-----------------------------------------------------------------------------
;    BL		Format: VI	Op-code: 0x0680		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_BL

	call	GetArgumentW
	mov	[ CpuMemoryW + _WP_ + 11 * 2 ], _PCw_
	mov	_PC_, ecx
	ret

ENDP	_opcode_BL

;-----------------------------------------------------------------------------
;    SWPB	Format: VI	Op-code: 0x06C0		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SWPB

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	xchg	bh, bl
	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	_opcode_SWPB

;-----------------------------------------------------------------------------
;    SETO	Format: VI	Op-code: 0x0700		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SETO

	call	GetArgumentW
	mov	ebx, -1
	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	_opcode_SETO

;-----------------------------------------------------------------------------
;    ABS	Format: VI	Op-code: 0x0740		Status: L A E - O - -
;-----------------------------------------------------------------------------
PROC	_opcode_ABS

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	cmp	bx, 0
	setl	[ flagOverflow ]
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	jge	@@Done
	neg	[ CpuMemoryW + ecx ]
@@Done:	ret

ENDP	_opcode_ABS

;-----------------------------------------------------------------------------
;    SRA	Format: V	Op-code: 0x0800		Status: L A E C - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SRA

	mov	ecx, eax
	and	eax, 0000000Fh
	shr	ecx, 4
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	cx, [ CpuMemoryW + _WP_ + 0 * 2 ]
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	ecx, 16

@@ValidShift:

	movsx	ebx, [ CpuMemoryW + _WP_ + eax * 2 ]
	sar	ebx, cl
	setc	[ flagCarry ]
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_SRA

;-----------------------------------------------------------------------------
;    SRL	Format: V	Op-code: 0x0900		Status: L A E C - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SRL

	mov	ecx, eax
	and	eax, 0000000Fh
	shr	ecx, 4
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	cx, [ CpuMemoryW + _WP_ + 0 * 2 ]
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	ecx, 16

@@ValidShift:

	movzx	ebx, [ CpuMemoryW + _WP_ + eax * 2 ]
	shr	ebx, cl
	setc	[ flagCarry ]
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_SRL

;-----------------------------------------------------------------------------
;    SLA	Format: V	Op-code: 0x0A00		Status: L A E C O - -
;
; Comments: The overflow bit is set if the sign changes during the shift
;-----------------------------------------------------------------------------
PROC	_opcode_SLA

	mov	ecx, eax
	and	eax, 0000000Fh
	shr	ecx, 4
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	cx, [ CpuMemoryW + _WP_ + 0 * 2 ]
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	ecx, 16

@@ValidShift:

	movsx	ebx, [ CpuMemoryW + _WP_ + eax * 2 ]
	sal	ebx, cl
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	shr	ebx, 16
	je	@@NoBits
	test	ebx, 1
	setne	[ flagCarry ]
	inc	ebx
	setne	[ flagOverflow ]
	ret

@@NoBits:

	mov	[ flagCarry ], 0
	mov	[ flagOverflow ], 0
	ret

ENDP	_opcode_SLA

;-----------------------------------------------------------------------------
;    SRC	Format: V	Op-code: 0x0B00		Status: L A E C - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SRC

	mov	ecx, eax
	and	eax, 0000000Fh
	shr	ecx, 4
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	cx, [ CpuMemoryW + _WP_ + 0 * 2 ]
	and	ecx, 0000000Fh
	jne	@@ValidShift
	mov	ecx, 16

@@ValidShift:

	movzx	ebx, [ CpuMemoryW + _WP_ + eax * 2 ]
	ror	bx, cl
	setc	[ flagCarry ]
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_SRC

;-----------------------------------------------------------------------------
;    JMP	Format: II	Op-code: 0x1000		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JMP

	movsx	eax, al
	lea	_PCw_, [ _PC_ + eax * 2 ]
	ret

ENDP	_opcode_JMP

;-----------------------------------------------------------------------------
;    JLT	Format: II	Op-code: 0x1100		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JLT

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jl	_opcode_JMP
	ret

ENDP	_opcode_JLT

;-----------------------------------------------------------------------------
;    JLE	Format: II	Op-code: 0x1200		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JLE

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jbe	_opcode_JMP
	ret

ENDP	_opcode_JLE

;-----------------------------------------------------------------------------
;    JEQ	Format: II	Op-code: 0x1300		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JEQ

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	je	_opcode_JMP
	ret

ENDP	_opcode_JEQ

;-----------------------------------------------------------------------------
;    JHE	Format: II	Op-code: 0x1400		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JHE

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jae	_opcode_JMP
	ret

ENDP	_opcode_JHE

;-----------------------------------------------------------------------------
;    JGT	Format: II	Op-code: 0x1500		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JGT

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jg	_opcode_JMP
	ret

ENDP	_opcode_JGT

;-----------------------------------------------------------------------------
;    JNE	Format: II	Op-code: 0x1600		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JNE

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jne	_opcode_JMP
	ret

ENDP	_opcode_JNE

;-----------------------------------------------------------------------------
;    JNC	Format: II	Op-code: 0x1700		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JNC

	cmp	[ flagCarry ], 0
	je	_opcode_JMP
	ret

ENDP	_opcode_JNC

;-----------------------------------------------------------------------------
;    JOC	Format: II	Op-code: 0x1800		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JOC

	cmp	[ flagCarry ], 0
	jne	_opcode_JMP
	ret

ENDP	_opcode_JOC

;-----------------------------------------------------------------------------
;    JNO	Format: II	Op-code: 0x1900		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JNO

	cmp	[ flagOverflow ], 0
	je	_opcode_JMP
	ret

ENDP	_opcode_JNO

;-----------------------------------------------------------------------------
;    JL		Format: II	Op-code: 0x1A00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JL

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	jb	_opcode_JMP
	ret

ENDP	_opcode_JL

;-----------------------------------------------------------------------------
;    JH		Format: II	Op-code: 0x1B00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JH

	mov	ebx, [ srcComp ]
	cmp	bx, [ word ptr dstComp ]
	ja	_opcode_JMP
	ret

ENDP	_opcode_JH

;-----------------------------------------------------------------------------
;    JOP	Format: II	Op-code: 0x1C00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_JOP

	cmp	[ flagParity ], 0
	jne	_opcode_JMP
	ret

ENDP	_opcode_JOP
;-----------------------------------------------------------------------------
;    SBO	Format: II	Op-code: 0x1D00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SBO

	movzx	ebx, [ CpuMemoryW + _WP_ + 12 * 2 ]
	shr	ebx, 1
	and	eax, 000000FFh
	add	ebx, eax
	push	esi
	push	edx
	push	1
	push	1
	push	ebx
	push	[_CRU_Object]
	call	_WriteCRU
	pop	ebx
	pop	ebx
	pop	ebx
	pop	ebx
	pop	edx
	pop	esi
	and	al, 1
	shl	al, 5
	or	dl, al
	ret

ENDP	_opcode_SBO

;-----------------------------------------------------------------------------
;    SBZ	Format: II	Op-code: 0x1E00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SBZ

	movzx	ebx, [ CpuMemoryW + _WP_ + 12 * 2 ]
	shr	ebx, 1
	and	eax, 000000FFh
	add	ebx, eax
	push	esi
	push	edx
	push	0
	push	1
	push	ebx
	push	[_CRU_Object]
	call	_WriteCRU
	pop	ebx
	pop	ebx
	pop	ebx
	pop	ebx
	pop	edx
	pop	esi
	and	al, 1
	shl	al, 5
	or	dl, al
	ret

ENDP	_opcode_SBZ

;-----------------------------------------------------------------------------
;    TB		Format: II	Op-code: 0x1F00		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_TB

	movzx	ebx, [ CpuMemoryW + _WP_ + 12 * 2 ]
	shr	ebx, 1
	and	eax, 000000FFh
	add	ebx, eax
	push	esi
	push	edx
	push	1
	push	ebx
	push	[_CRU_Object]
	call	_ReadCRU
	pop	ebx
	pop	ebx
	pop	ebx
	pop	edx
	pop	esi
	and	eax, 1
	mov	[ srcComp ], eax
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_TB

;-----------------------------------------------------------------------------
;    COC	Format: III	Op-code: 0x2000		Status: - - E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_COC

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	shr	eax, 6
	and	eax, 0000000Fh
	mov	edi, ebx
	and	bx, [ CpuMemoryW + _WP_ + eax * 2 ]
	mov	[ srcComp ], ebx
	mov	[ dstComp ], edi
	ret

ENDP	_opcode_COC

;-----------------------------------------------------------------------------
;    CZC	Format: III	Op-code: 0x2400		Status: - - E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_CZC

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	shr	eax, 6
	and	eax, 0000000Fh
	mov	di, [ CpuMemoryW + _WP_ + eax * 2 ]
	not	di
	and	di, bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], edi
	ret

ENDP	_opcode_CZC

;-----------------------------------------------------------------------------
;    XOR	Format: III	Op-code: 0x2800		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_XOR

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	shr	eax, 6
	and	eax, 0000000Fh
	mov	dx, [ CpuMemoryW + _WP_ + eax * 2 ]
	xor	bx, dx
	mov	[ CpuMemoryW + _WP_ + eax * 2 ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_XOR

;-----------------------------------------------------------------------------
;    XOP	Format: IX	Op-code: 0x2C00		Status: - - - - - - X
;-----------------------------------------------------------------------------
PROC	_opcode_XOP

	call	GetArgumentW
	mov	edi, ebx		; return Address
	shr	eax, 4
	and	eax, 0000003Ch
	lea	ecx, [ eax + 64 ]
	movzx	eax, [ CpuMemoryW + ecx ]
	movzx	ebx, [ CpuMemoryW + ecx + 2]
	call	ContextSwitch
	mov	[ CpuMemoryW + _WP_ + 11 * 2 ], di
	mov	[ flagXOP ], 1
	ret

ENDP	_opcode_XOP

;-----------------------------------------------------------------------------
;    LDCR	Format: IV	Op-code: 0x3000		Status: L A E - - P -
;-----------------------------------------------------------------------------
PROC	_opcode_LDCR

;    USHORT address = GetSrcAddress () & 0xFFFE;
;    USHORT value = ReadMemoryW ( address );

;    int cru = ReadRegisterW ( 12 ) >> 1;

	movzx	edi, [ CpuMemoryW + _WP_ + 12 * 2 ]
	shr	edi, 1
	and	edi, 00000FFFh

;    int count = ( curOpCode >> 6 ) & 0x000F;

	mov	edx, eax
	shr	edx, 6
	and	edx, 0000000Fh

;    if ( count == 0 ) count = 16;
;    if ( count < 9 ) {
;        value >>= 8;
;        _Compare_ (( UCHAR ) value, 0 );
;    } else
;        _Compare_ ( value, 0 );

	cmp	edx, 0
	je	@@SetSixteen
	cmp	edx, 9
	jge	@@Word

	push	edx
	call	GetArgumentB
	movsx	ebx, [ CpuMemoryB + ecx ]

	cmp	bl, 0
	setpo	[ flagParity ]
	mov	[ srcComp ], ebx
	jmp	@@Write

@@SetSixteen:
	mov	edx, 16
@@Word:
	push	edx
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	mov	[ srcComp ], ebx

;    while ( count-- ) {
;        WriteCRU ( cru++, ( value & 1 ) ? 1 : 0 );
;        value >>= 1;
;    }

@@Write:
	pop	edx
	mov	[ dstComp ], 0

	push	esi

	push	ebx
	push	edx
	push	edi
	push	[_CRU_Object]
	call	_WriteCRU
	pop	ebx
	pop	ebx
	pop	ebx
	pop	ebx

	pop	esi

	ret

ENDP	_opcode_LDCR

;-----------------------------------------------------------------------------
;    STCR	Format: IV	Op-code: 0x3400		Status: L A E - - P -
;-----------------------------------------------------------------------------
PROC	_opcode_STCR

;    USHORT address = GetSrcAddress () & 0xFFFE;

	mov	ecx, eax

;    int cru = ReadRegisterW ( 12 ) >> 1;

	movzx	edi, [ CpuMemoryW + _WP_ + 12 * 2 ]
	shr	edi, 1
	and	edi, 00000FFFh

;    int count = ( curOpCode >> 6 ) & 0x000F;

	shr	eax, 6
	and	eax, 0000000Fh

;    if ( count == 0 ) count = 16;

	sete	bl
	shl	bl, 4
	or	al, bl

;        while ( count-- ) {
;            value <<= 1;
;            value |= ReadCRU ( cru++ );
;        }

	push	esi
	push	ecx

	push	eax
	push	edi
	push	[_CRU_Object]
	call	_ReadCRU
	pop	ebx
	pop	ebx
	pop	edi

	pop	ecx
	pop	esi

;    if ( count < 9 ) {
;        _Compare_ ( value, 0 );
;        WriteMemory ( address, value );
;    } else {
;        _Compare_ ( value, 0 );
;        WriteMemory ( address, value );
;    }

        mov	edx, eax
        mov	eax, ecx

 	cmp	edi, 9
	jge	@@Word

	call	GetArgumentB
	push	ecx
	movzx	ebx, [ CpuMemoryB + ecx ]
	mov	ecx, edi
	shl	bl, cl
	or	bl, dl
	setpo	[ flagParity ]
	movsx	edx, bl
	mov	[ srcComp ], edx
	mov	[ dstComp ], 0
	pop	ecx
	mov	[ CpuMemoryB + ecx ], bl
	ret

@@Word:

	call	GetArgumentW
	push	ecx
	movzx	ebx, [ CpuMemoryW + ecx ]
	mov	ecx, edi
	shl	ebx, cl
	or	ebx, edx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	pop	ecx
	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	_opcode_STCR

;-----------------------------------------------------------------------------
;    MPY	Format: IX	Op-code: 0x3800		Status: - - - - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_MPY

	call	GetArgumentW
	movzx	edx, [ CpuMemoryW + ecx ]
	shr	eax, 6
	and	al, 0Fh
	call	GetArgumentW
	movzx	eax, [ CpuMemoryW + ecx ]
	mul	dx
	mov	[ CpuMemoryW + ecx ], dx
	mov	[ CpuMemoryW + ecx + 2 ], ax
	ret

ENDP	_opcode_MPY

;-----------------------------------------------------------------------------
;    DIV	Format: IX	Op-code: 0x3C00		Status: - - - - O - -
;-----------------------------------------------------------------------------
PROC	_opcode_DIV

	call	GetArgumentW
	movzx	edi, [ CpuMemoryW + ecx ]
	shr	eax, 6
	and	al, 0Fh
	call	GetArgumentW
	movzx	edx, [ CpuMemoryW + ecx ]
	cmp	edx, edi
	jg	@@Overflow
	movzx	eax, [ CpuMemoryW + ecx + 2 ]
	div	di
	mov	[ CpuMemoryW + ecx ], ax		; quotient
	mov	[ CpuMemoryW + ecx + 2 ], dx		; remainder
	mov	[ flagOverflow ], 0
	ret

@@Overflow:

	mov	[ flagOverflow ], 0
	ret

ENDP	_opcode_DIV

;-----------------------------------------------------------------------------
;    SZC	Format: I	Op-code: 0x4000		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SZC

	call	GetArgumentW
	movzx	edi, [ CpuMemoryW + ecx ]
	not	edi
	shr	eax, 6
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	and	bx, di
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_SZC

;-----------------------------------------------------------------------------
;    SZCB	Format: I	Op-code: 0x5000		Status: L A E - - P -
;-----------------------------------------------------------------------------
PROC	_opcode_SZCB

	call	GetArgumentB
	call	_ReadMemoryB
	not	ebx
	shr	eax, 6
	mov	ah, bl
	call	GetArgumentB
	call	_ReadMemoryB
	and	bl, ah
        movsx	bx, bl
	setpo	[ flagParity ]
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	call	_WriteMemoryB
	ret

ENDP	_opcode_SZCB

;-----------------------------------------------------------------------------
;    S		Format: I	Op-code: 0x6000		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_S

	call	GetArgumentW
	movzx	edi, [ CpuMemoryW + ecx ]
	shr	eax, 6
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	sub	bx, di
	setnc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov	[ CpuMemoryW + ecx ], bx
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_S

;-----------------------------------------------------------------------------
;    SB		Format: I	Op-code: 0x7000		Status: L A E C O P -
;-----------------------------------------------------------------------------
PROC	_opcode_SB

	call	GetArgumentB
	call	_ReadMemoryB
	shr	eax, 6
	mov	ah, bl
	call	GetArgumentB
	call	_ReadMemoryB
	sub	bl, ah
	movsx	bx, bl
	setnc	[ flagCarry ]
	seto	[ flagOverflow ]
	setpo	[ flagParity ]
	mov	[ srcComp ], ebx
	mov	[ dstComp ], 0
	call	_WriteMemoryB
	ret

ENDP	_opcode_SB

;-----------------------------------------------------------------------------
;    C		Format: I	Op-code: 0x8000		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_C

	call	GetArgumentW
	movzx	edi, [ CpuMemoryW + ecx ]
	shr	eax, 6
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	mov	[ srcComp ], edi
	mov	[ dstComp ], ebx
	ret

ENDP	_opcode_C

;-----------------------------------------------------------------------------
;    CB		Format: I	Op-code: 0x9000		Status: L A E - - P -
;-----------------------------------------------------------------------------
PROC	_opcode_CB

	call	GetArgumentB
	call	_ReadMemoryB
	cmp     bl, 0
	setpo	[ flagParity ]
	mov	[ srcComp ], ebx
	shr	eax, 6
	call	GetArgumentB
	call	_ReadMemoryB
	mov	[ dstComp ], ebx
	ret

ENDP	_opcode_CB

;-----------------------------------------------------------------------------
;    A		Format: I	Op-code: 0xA000		Status: L A E C O - -
;-----------------------------------------------------------------------------
PROC	_opcode_A

	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	mov	edi, ebx
	shr	eax, 6
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	add	bx, di
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	_opcode_A

;-----------------------------------------------------------------------------
;    AB		Format: I	Op-code: 0xB000		Status: L A E C O P -
;-----------------------------------------------------------------------------
PROC	_opcode_AB

	call	GetArgumentB
	call	_ReadMemoryB
	shr	eax, 6
	mov	edi, ebx
	call	GetArgumentB
	call	_ReadMemoryB
	add	ebx, edi
	movsx	bx, bl
	setc	[ flagCarry ]
	seto	[ flagOverflow ]
	setpo	[ flagParity ]
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	call	_WriteMemoryB
	ret

ENDP	_opcode_AB

;-----------------------------------------------------------------------------
;    MOV	Format: I	Op-code: 0xC000		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_MOV

	call	GetArgumentW
        call    _ReadMemoryW
	shr	eax, 6
	call	GetArgumentW
        call    _WriteMemoryW
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_MOV

;-----------------------------------------------------------------------------
;    MOVB	Format: I	Op-code: 0xD000		Status: L A E - - P -
;-----------------------------------------------------------------------------
PROC	_opcode_MOVB

	call	GetArgumentB
	call	_ReadMemoryB
	shr	eax, 6
	call	GetArgumentB
	call	_WriteMemoryB
	cmp	bl, 0
	setpo	[ flagParity ]
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	ret

ENDP	_opcode_MOVB

;-----------------------------------------------------------------------------
;    SOC	Format: I	Op-code: 0xE000		Status: L A E - - - -
;-----------------------------------------------------------------------------
PROC	_opcode_SOC

	call	GetArgumentW
	movzx	edi, [ CpuMemoryW + ecx ]
	shr	eax, 6
	call	GetArgumentW
	movzx	ebx, [ CpuMemoryW + ecx ]
	or	bx, di
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	mov	[ CpuMemoryW + ecx ], bx
	ret

ENDP	_opcode_SOC

;-----------------------------------------------------------------------------
;    SOCB	Format: I	Op-code: 0xF000		Status: L A E - - P -
;-----------------------------------------------------------------------------

PROC	_opcode_SOCB

	call	GetArgumentB
	call	_ReadMemoryB
	shr	eax, 6
	mov	ah, bl
	call	GetArgumentB
	call	_ReadMemoryB
	or	bl, ah
	movsx	bx, bl
	setpo	[ flagParity ]
	mov 	[ srcComp ], ebx
	mov	[ dstComp ], 0
	call	_WriteMemoryB
	ret

ENDP	_opcode_SOCB

	END