;----------------------------------------------------------------------------
;
; File:        tms9900.inc
; Date:        23-Feb-1998
; Programmer:  Marc Rousseau
;
; Description:
;
; Copyright (c) 1998-2000 Marc Rousseau, All Rights Reserved.
;
; This program is free software; you can redistribute it and/or modify
; it under the terms of the GNU General Public License as published by
; the Free Software Foundation; either version 2 of the License, or
; (at your option) any later version.
;
; This program is distributed in the hope that it will be useful,
; but WITHOUT ANY WARRANTY; without even the implied warranty of
; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; GNU General Public License for more details.
;
; You should have received a copy of the GNU General Public License
; along with this program; if not, write to the Free Software
; Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
;
; Revision History:
;
;----------------------------------------------------------------------------

%define _WP_		ebp
%define _WPw_		bp
%define _PC_		esi
%define _PCw_		si
%define _ST_		edx
%define _STw_		dx

%define TMS_LOGICAL	080h
%define TMS_ARITHMETIC	040h
%define TMS_EQUAL	020h
%define TMS_CARRY	010h
%define TMS_OVERFLOW	008h
%define TMS_PARITY	004h
%define TMS_XOP		002h

%define MEMFLG_READ	080h
%define MEMFLG_WRITE	040h
%define MEMFLG_ACCESS	0C0h
%define MEMFLG_ROM	020h

%MACRO	CallTrapByte	1
	movzx	ebx, bl
	push	edi
	push	esi
	push	edx
	push	eax
	push	ebx
	movzx	eax, byte [ MemFlags + ecx ]
	and	eax, byte 0000000Fh
	xor	ecx, 1
	push	ecx
	push	eax
	push	dword %1
	call	CallTrap
	pop	ecx
	pop	ecx
	pop	ecx
	xor	ecx, byte 1
        pop	ebx
        push	eax
	pop	ebx
	pop	eax
	pop	edx
	pop	esi
	pop	edi
	movsx	ebx, bl
%ENDMACRO

%MACRO	CallTrapWord	1
	push	edi
	push	esi
	push	edx
	push	eax
        xchg    bh, bl
	movzx	eax, byte [ MemFlags + ecx ]
	and	eax, byte 0000000Fh
	push	ebx
	push	ecx
	push	eax
	push	dword %1
	call	CallTrap
	pop	ecx
	pop	ecx
	pop	ecx
        pop	ebx
        push	eax
	pop	ebx
        xchg    bh, bl
	pop	eax
	pop	edx
	pop	esi
	pop	edi
%ENDMACRO

%MACRO PROC 1
	%1:
%ENDMACRO

%MACRO ENDP 1
%ENDMACRO

%ifdef WIN32

%MACRO CODESEG 0
	SEGMENT	_TEXT PUBLIC CLASS=CODE USE32
%ENDMACRO

%MACRO DATASEG 0
	SEGMENT	_DATA PUBLIC CLASS=DATA USE32
%ENDMACRO

%MACRO UDATASEG 0
	SEGMENT	_BSS PUBLIC CLASS=BSS USE32
%ENDMACRO

%MACRO CGLOBAL 1-*
%rep %0
          global _%1
%define %1 _%1
%rotate 1
%endrep
%ENDMACRO

%MACRO CEXTERN 1-*
%rep %0
          extern _%1
%define %1 _%1
%rotate 1
%endrep
%ENDMACRO

%else

%MACRO CODESEG 0
	SEGMENT	.text
%ENDMACRO

%MACRO DATASEG 0
	SEGMENT	.data
%ENDMACRO

%MACRO UDATASEG 0
	SEGMENT	.bss
%ENDMACRO

%MACRO CGLOBAL 1-*
%rep %0
          global %1
%rotate 1
%endrep
%ENDMACRO

%MACRO CEXTERN 1-*
%rep %0
          extern %1
%rotate 1
%endrep
%ENDMACRO

%endif
