//----------------------------------------------------------------------------
//
// File:	main.cpp
// Date:	2-April-2000
// Programmer:	Marc Rousseau
//
// Description: This file contains starup code for Linux/SDL
//
// Copyright (c) 2000 Marc Rousseau, All Rights Reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307, USA.
//
// Revision History:
//
//----------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include "common.hpp"
#include "logger.hpp"
#include "cartridge.hpp"
#include "SDL.h"
#include "tms9900.hpp"
#include "ti994a.hpp"
#include "ti994a-sdl.hpp"
#include "tms9918a.hpp"
#include "tms9918a-sdl.hpp"

void dprintf ( const char *, ... ) {}

int main ( int, char *argv [] )
{
    FUNCTION_ENTRY ( NULL, "main", true );

    // Initialize the SDL library (starts the event loop)
    if ( SDL_Init ( SDL_INIT_VIDEO ) < 0 ) {
        fprintf ( stderr, "Couldn't initialize SDL: %s\n", SDL_GetError ());
        return -1;
    }

    // Clean up on exit, exit on window close and interrupt
    atexit ( SDL_Quit );

    cSdlTI994A computer ( new cCartridge ( "TI-994A.ctg" ));
    cCartridge ctg ( argv [1] );
    computer.InsertCartridge ( &ctg );
    computer.Run ();

    return 0;
}
